/* This file was generated by scramble.py. */
#line 1 "src/animation.py"
#include "animation.h"
static void draw(LandSprite * self, LandView * view);
static int overlap(LandSprite * self, LandSprite * other);
#line 22
static LandArray * animations;
#line 24
void animation_destroy_all(void) {
    {
#line 25
        LandArrayIterator __iter0__ = LandArrayIterator_first(animations);
#line 25
        for (Animation * a = LandArrayIterator_item(animations, &__iter0__); LandArrayIterator_next(animations, &__iter0__); a = LandArrayIterator_item(animations, &__iter0__)) {
            land_array_destroy(a->frames);
            land_free(a);
        }
    }
}
#line 30
Animation* animation_new(Atlas * atlas, char const * name, int frame_count, float movement, float radius) {
    Animation * self;
    land_alloc(self);
    self->frame_count = frame_count;
    self->frames = land_array_new();
    for (int d = 0; d < 8; d += 1) {
        for (int i = 0; i < frame_count; i += 1) {
            char fname [100];
            sprintf(fname, "%s_%04d%d.png", name, 1 + i, d);
#line 40
            land_array_add(self->frames, atlas_load_picture(atlas, fname));
        }
    }
#line 41
    self->super.draw = draw;
    self->super.overlap = overlap;
    self->super.w = 64;
    self->super.h = 64;
    self->super.x = 32;
    self->super.y = 32;
    self->radius = radius;
    self->movement = movement;
    if (! animations) {
        animations = land_array_new();
    }
#line 51
    land_array_add(animations, self);
    return self;
}
static void draw(LandSprite * self, LandView * view) {
    sprite_draw((void *) self, view);
}
static int overlap(LandSprite * self, LandSprite * other) {
    Animation * a = (void *) self->type;
    Animation * o = (void *) other->type;
    LandFloat dx = other->x + o->super.w / 2 - self->x - a->super.w / 2;
    LandFloat dy = other->y + o->super.h / 2 - self->y - a->super.h / 2;
    dy *= 2;
    LandFloat r = a->radius + o->radius;
    if (dx * dx + dy * dy < r * r) {
        return 1;
    }
#line 66
    return 0;
}
/* This file was generated by scramble.py. */
