/* This file was generated by scramble.py. */
#line 1 "src/atlas.py"
#include "atlas.h"
#line 17
Atlas* atlas_new(char const * filename) {
    Atlas * self;
    land_alloc(self);
    self->sheets = land_array_new();
    self->sprites = land_hash_new();
    self->filename = land_strdup(filename);
#line 24
    atlas_load_all(self);
    return self;
}
void atlas_destroy(Atlas * self) {
    {
#line 28
        LandArrayIterator __iter0__ = LandArrayIterator_first(self->sheets);
#line 28
        for (AtlasSheet * sheet = LandArrayIterator_item(self->sheets, &__iter0__); LandArrayIterator_next(self->sheets, &__iter0__); sheet = LandArrayIterator_item(self->sheets, &__iter0__)) {
            land_image_destroy(sheet->image);
            land_free(sheet->filename);
            land_free(sheet);
        }
    }
#line 32
    {
#line 32
        LandHashIterator __iter0__ = LandHashIterator_first(self->sprites);
#line 32
        for (AtlasSprite * s = LandHashIterator_item(self->sprites, &__iter0__); LandHashIterator_next(self->sprites, &__iter0__); s = LandHashIterator_item(self->sprites, &__iter0__)) {
            land_free(s);
        }
    }
#line 34
    land_array_destroy(self->sheets);
    land_hash_destroy(self->sprites);
    land_free(self->filename);
    land_free(self);
}
AtlasSheet* atlas_find_sheet(Atlas * self, char const * name) {
    {
#line 40
        LandArrayIterator __iter0__ = LandArrayIterator_first(self->sheets);
#line 40
        for (AtlasSheet * sheet = LandArrayIterator_item(self->sheets, &__iter0__); LandArrayIterator_next(self->sheets, &__iter0__); sheet = LandArrayIterator_item(self->sheets, &__iter0__)) {
            if (land_equals(name, sheet->filename)) {
                return sheet;
            }
        }
    }
#line 43
    return NULL;
}
void atlas_load_all(Atlas * self) {
    char * text = land_read_text(self->filename);
    LandArray * a = land_split_lines(text);
#line 49
    {
#line 49
        LandArrayIterator __iter0__ = LandArrayIterator_first(a);
#line 49
        for (char * row = LandArrayIterator_item(a, &__iter0__); LandArrayIterator_next(a, &__iter0__); row = LandArrayIterator_item(a, &__iter0__)) {
            char * path = row;
            char * colon = strchr(path, ':');
            if (! colon) {
                break;
            }
#line 54
            * colon = '\0';
            char * sheet = colon + 2;
            char * space = strchr(sheet, ' ');
            * space = '\0';
            AtlasSprite * s;
            land_alloc(s);
            AtlasSheet * atlas_sheet = atlas_find_sheet(self, sheet);
            if (! atlas_sheet) {
                land_alloc(atlas_sheet);
                atlas_sheet->filename = land_strdup(sheet);
                atlas_sheet->id = land_array_count(self->sheets);
                land_array_add(self->sheets, atlas_sheet);
                char * sheet_path = land_replace_filename(self->filename, sheet);
                atlas_sheet->image = land_image_load(sheet_path);
                land_free(sheet_path);
            }
#line 69
            s->sheet = atlas_sheet;
#line 71
            sscanf(space + 1, " %d %d %d %d %d %d\n", & s->x, & s->y, & s->w, & s->h, & s->ox, & s->oy);
            land_hash_insert(self->sprites, path, s);
        }
    }
#line 74
    land_free(text);
    land_array_destroy_with_strings(a);
}
AtlasSprite* atlas_load_picture(Atlas * self, char const * filename) {
    return land_hash_get(self->sprites, filename);
}
/* This file was generated by scramble.py. */
