/* This file was generated by scramble.py. */
#line 1 "src/game.py"
#include "game.h"
#define _scramble_max(x, y) ((y) > (x) ? (y) : (x))
static void next_song(void);
static void missed_gifts(bool ignore);
static void handle_triggers(bool ignore);
static bool is_dead(Sprite * s);
static void draw(LandRunner * runner);
static void draw_bard(void);
static void text_color_gold(int number);
static void text_color_blue(int number);
static void text_color_health(int number);
static void card(char const * title, int number, int maximum, int x, int y, int w, int h, void(* text_color_cb)(int x));
static void bubble(LandArray * text, Sprite * who);
#line 14
LandRunner * _runner;
Game * game;
int reload_font_ticks;
#line 85
Game* game_global(void) {
    return game;
}
static void next_song(void) {
    char const * name = NULL;
    if (game->song == 0) {
#line 90
        name = "data/march of the three kings.ogg";
    }
#line 91
    if (game->song == 1) {
#line 91
        name = "data/we three kings of orient are.ogg";
    }
#line 92
    if (game->song == 2) {
#line 92
        name = "data/march of the three kings.ogg";
    }
#line 93
    if (game->song == 3) {
#line 93
        name = "data/calypso carol.ogg";
    }
#line 94
    if (game->song == 4) {
#line 94
        name = "data/march of the three kings.ogg";
    }
#line 95
    if (game->song == 5) {
#line 95
        name = "data/little donkey.ogg";
    }
#line 96
    game->song++;
    game->song %= 6;
    print("playing %s", name);
    land_stream_music_once(game->stream, name);
}
void game_new(void) {
    land_alloc(game);
#line 104
    game->music = 1;
    game->stream = land_stream_new(2048, 4, 22050, 16, 2);
    next_song();
#line 108
    game->triggers = land_array_new();
#line 110
    game->map = land_map_new();
#line 112
    game->layer = land_layer_new_with_grid(land_sprites_grid_new(40, 20, 2000, 36));
    game->grid = game->layer->grid;
    land_map_add_layer(game->map, game->layer);
    game->view = land_view_new(0, 0, 1280, 720);
    game->speed = 1;
#line 118
    game->monsters = land_array_new();
    game->kings = land_array_new();
#line 121
    game->caspar = king_new(load_animation("caspar"));
    game->melchior = king_new(load_animation("melchior"));
    game->balthasar = king_new(load_animation("balthasar"));
    game->bard = sprite_new(load_animation("bard"));
    game->grizzly = load_animation("grizzly");
    game->krampus = load_animation("krampus");
    game->boar = load_animation("boar");
    game->wolf = load_animation("wolf");
    game->sheep = load_animation("sheep");
    game->shepherd = load_animation("shepherd");
    game->coin = load_animation("coin");
    game->myrrh = load_animation("myrrh");
    game->frankincense = load_animation("frankincense");
    game->trees [1] = load_animation("spruce_fallen");
    game->trees [2] = load_animation("spruce_dead");
    game->trees [3] = load_animation("spruce");
    game->trees [4] = load_animation("pine_fallen");
    game->trees [5] = load_animation("pine_dead");
    game->trees [6] = load_animation("pine");
    game->logcabin = load_animation("logcabin");
#line 142
    level_create();
#line 144
    place_kings();
#line 146
    ui_init();
#line 148
    game->debug = 1;
}
void game_free(void) {
    ui_reset();
    if (game->message) {
        land_array_destroy_with_strings(game->message);
    }
#line 154
    LandArray * all = land_sprites_grid_get_all(game->grid);
    {
#line 155
        LandArrayIterator __iter0__ = LandArrayIterator_first(all);
#line 155
        for (LandSprite * s = LandArrayIterator_item(all, &__iter0__); LandArrayIterator_next(all, &__iter0__); s = LandArrayIterator_item(all, &__iter0__)) {
            land_sprite_destroy(s);
        }
    }
#line 157
    land_array_destroy(all);
    {
#line 158
        LandArrayIterator __iter0__ = LandArrayIterator_first(game->levels);
#line 158
        for (Level * l = LandArrayIterator_item(game->levels, &__iter0__); LandArrayIterator_next(game->levels, &__iter0__); l = LandArrayIterator_item(game->levels, &__iter0__)) {
            land_free(l);
        }
    }
#line 160
    {
#line 160
        LandArrayIterator __iter0__ = LandArrayIterator_first(game->triggers);
#line 160
        for (Trigger * t = LandArrayIterator_item(game->triggers, &__iter0__); LandArrayIterator_next(game->triggers, &__iter0__); t = LandArrayIterator_item(game->triggers, &__iter0__)) {
            land_free(t);
        }
    }
#line 162
    land_array_destroy(game->triggers);
    land_array_destroy(game->levels);
    land_sprite_destroy((void *) game->bard);
    land_array_destroy(game->monsters);
    land_array_destroy(game->kings);
    land_map_destroy(game->map);
    land_view_destroy(game->view);
    land_stream_destroy(game->stream);
    land_free(game);
    game = NULL;
}
void game_reset(void) {
    game_free();
    game_new();
}
void game_speed(double speed) {
    if (speed > 2.5) {
        speed = 2.5;
    }
#line 180
    game->speed = speed;
}
void place_kings(void) {
    land_sprite_place_into_grid((void *) game->caspar, game->grid, 50, 360);
    land_sprite_place_into_grid((void *) game->melchior, game->grid, 200, 340);
    land_sprite_place_into_grid((void *) game->balthasar, game->grid, 200, 380);
    land_array_add(game->kings, game->caspar);
    land_array_add(game->kings, game->melchior);
    land_array_add(game->kings, game->balthasar);
}
void init(LandRunner * runner) {
    land_display_title("Kings");
    load_atlas();
#line 194
    smoke_init();
#line 196
    game_new();
}
void enter(LandRunner * runner) {
#line 198
    ;
}
#line 201
void tick(LandRunner * runner) {
    if (land_was_resized()) {
        reload_font_ticks = 10;
    }
#line 204
    land_scale_to_fit(1280, 720, 256);
    LandFloat mx = land_mouse_x();
    LandFloat my = land_mouse_y();
    LandFloat z = 0;
    land_transform(& mx, & my, & z);
    bool mb = land_mouse_button(0);
    bool md = land_mouse_delta_button(0);
#line 212
    if (game->music && ! land_stream_is_playing(game->stream)) {
        next_song();
    }
    if (land_closebutton()) {
#line 215
        land_quit();
    }
#line 216
    if (land_key_pressed(LandKeyEscape)) {
#line 216
        land_quit();
    }
#line 217
    if (land_key_pressed(LandKeyFunction + 1)) {
#line 217
        debug_grid ^= 1;
    }
#line 218
    if (land_key_pressed(LandKeyFunction + 2)) {
#line 218
        debug_grid ^= 2;
    }
#line 219
    if (land_key_pressed('f')) {
#line 219
        land_display_toggle_fullscreen();
    }
#line 220
    if (land_key_pressed('p')) {
#line 220
        game->paused ^= 1;
    }
#line 221
    if (land_key_pressed(' ')) {
#line 221
        game->paused ^= 1;
    }
#line 222
    if (land_key_pressed('m')) {
        game->music = ! game->music;
        if (game->music) {
            land_stream_set_playing(game->stream, 1);
        }
#line 225
        else {
#line 227
            land_stream_set_playing(game->stream, 0);
        }
    }
#line 228
    if (land_key_pressed('r')) {
        game_reset();
#line 229
        return ;
    }
#line 232
    bool ui = 0;
    if (! game->selected) {
        ui = ui_tick(mx, my, mb, md);
    }
    if (game->debug) {
        int kx = 0, ky = 0;
        if (land_key(LandKeyRight)) {
#line 238
            kx = 1;
        }
#line 239
        if (land_key(LandKeyLeft)) {
#line 239
            kx = - 1;
        }
#line 240
        if (land_key(LandKeyDown)) {
#line 240
            ky = 1;
        }
#line 241
        if (land_key(LandKeyUp)) {
#line 241
            ky = - 1;
        }
#line 242
        int ln = land_array_count(game->levels) - 1;
        for (int i = 0; i < ln; i += 1) {
            bool kp = 0;
            if (i < 9) {
#line 245
                kp = land_key_pressed('1' + i);
            }
#line 245
            else {
                kp = land_key_pressed('a' + i - 9);
            }
#line 247
            if (kp) {
                Level * level = land_array_get_nth(game->levels, 1 + i);
                int x = level->x - 31;
                if (x < 0) {
#line 250
                    x = 0;
                }
#line 251
                land_view_scroll_to(game->view, x * 40, 0);
                handle_triggers(1);
                missed_gifts(1);
                for (int j = 0; j < 3; j += 1) {
                    LandSprite * k = land_array_get_nth(game->kings, j);
                    land_sprite_move_to(k, game->grid, x * 40 + 100 + j * 50, 360);
                }
            }
        }
#line 257
        land_view_scroll(game->view, kx, ky);
    }
    if (game->over) {
#line 259
        return ;
    }
#line 260
    if (game->paused) {
#line 260
        return ;
    }
#line 261
    land_view_scroll(game->view, 0.5 * game->speed, 0);
#line 263
    handle_triggers(false);
#line 265
    float vx, vy;
    land_view_to_world(game->view, mx, my, & vx, & vy);
#line 268
    LandList * l = NULL;
    if (! ui) {
        l = land_sprites_grid_get_circle(game->grid, vx, vy, 30);
    }
    if (mb && game->selected) {
        king_target(game->selected, vx + game->offset_x, vy + game->offset_y);
    }
    if (md) {
        if (game->selected) {
            game->selected = NULL;
        }
#line 278
        else if (mb && l) {
            float dx = 0;
            float dy = 0;
            {
#line 281
                LandListIterator __iter0__ = LandListIterator_first(l);
#line 281
                for (LandSprite * s = LandListIterator_item(l, &__iter0__); LandListIterator_next(l, &__iter0__); s = LandListIterator_item(l, &__iter0__)) {
                    Sprite * sprite = (void *) s;
                    {
#line 283
                        LandArrayIterator __iter1__ = LandArrayIterator_first(game->kings);
#line 283
                        for (Sprite * king = LandArrayIterator_item(game->kings, &__iter1__); LandArrayIterator_next(game->kings, &__iter1__); king = LandArrayIterator_item(game->kings, &__iter1__)) {
                            if (king == sprite) {
                                float dx2 = king->super.x - vx;
                                float dy2 = king->super.y - vy;
                                if (! game->selected || dx2 * dx2 + dy2 * dy2 < dx * dx + dy * dy) {
                                    dx = dx2;
                                    dy = dy2;
                                    game->selected = (void *) king;
                                    game->selected->target = 0;
                                }
                            }
                        }
                    }
                }
            }
#line 293
            game->offset_x = dx;
            game->offset_y = dy;
        }
    }
#line 296
    if (l) {
        land_list_destroy(l);
    }
    {
#line 299
        LandArrayIterator __iter0__ = LandArrayIterator_first(game->kings);
#line 299
        for (Sprite * k = LandArrayIterator_item(game->kings, &__iter0__); LandArrayIterator_next(game->kings, &__iter0__); k = LandArrayIterator_item(game->kings, &__iter0__)) {
            king_move(k);
        }
    }
#line 302
    {
#line 302
        LandArrayIterator __iter0__ = LandArrayIterator_first(game->monsters);
#line 302
        for (Sprite * m = LandArrayIterator_item(game->monsters, &__iter0__); LandArrayIterator_next(game->monsters, &__iter0__); m = LandArrayIterator_item(game->monsters, &__iter0__)) {
            Animation * a = (void *) m->super.type;
            if (a->bite > 0) {
                monster_move(m);
            }
#line 305
            else {
#line 307
                sheep_move(m);
            }
        }
    }
    // remove off screen or dead ones
#line 310
    int mi = 0;
    while (mi < land_array_count(game->monsters)) {
        Sprite * m = land_array_get_nth(game->monsters, mi);
        if (is_dead(m)) {
            land_sprite_hide(& m->super, game->grid);
            land_sprite_destroy(& m->super);
            Sprite * ml = land_array_pop(game->monsters);
            land_array_replace_nth(game->monsters, mi, ml);
        }
#line 317
        else {
#line 319
            mi++;
        }
    }
    // detect missed gifts
#line 322
    missed_gifts(0);
#line 324
    if (is_dead(game->caspar)) {
#line 324
        game->over = "Oh no! We lost Caspar!";
    }
#line 325
    if (is_dead(game->melchior)) {
#line 325
        game->over = "Oh no! We lost Melchior!";
    }
#line 326
    if (is_dead(game->balthasar)) {
#line 326
        game->over = "Oh no! We lost Balthasar!";
    }
    smoke_tick();
#line 330
    game->bardx++;
    if (game->bardx >= 700) {
        game->bardx -= 700;
    }
#line 333
    if (game->bardx % 10 == 0) {
        smoke_add_firework(game->bard->super.x, game->bard->super.y);
    }
    game->tick++;
}
static void missed_gifts(bool ignore) {
    int x = game->view->scroll_x;
    LandList * off = land_sprites_grid_get_rectangle(game->grid, x - 60, 0, x - 60, 720);
    if (off) {
        {
#line 342
            LandListIterator __iter0__ = LandListIterator_first(off);
#line 342
            for (LandSprite * s = LandListIterator_item(off, &__iter0__); LandListIterator_next(off, &__iter0__); s = LandListIterator_item(off, &__iter0__)) {
                if (game->over) {
#line 343
                    continue;
                }
#line 344
                if (s->type == (void *) game->coin) {
#line 344
                    game->over = "Caspar missed some gold!";
                }
#line 345
                if (s->type == (void *) game->frankincense) {
#line 345
                    game->over = "Melchior missed some frankincense!";
                }
#line 346
                if (s->type == (void *) game->myrrh) {
#line 346
                    game->over = "Balthasar missed some myrrh!";
                }
#line 347
                if (game->over) {
                    if (ignore) {
                        land_sprite_hide(s, game->grid);
                        game->over = NULL;
                    }
#line 350
                    else {
#line 352
                        land_view_scroll(game->view, - 60, 0);
                        game->over_sprite = (void *) s;
                    }
                }
            }
        }
#line 354
        land_list_destroy(off);
    }
}
#line 356
static void handle_triggers(bool ignore) {
    while (game->trigger < land_array_count(game->triggers)) {
        Trigger * t = land_array_get_nth(game->triggers, game->trigger);
        if (t->x * 40 < game->view->scroll_x + 32 * 40) {
            if (t->special && land_equals(t->special, "steed")) {
#line 362
                king_target((void *) game->melchior, game->melchior->super.x + 200, game->melchior->super.y);
            }
#line 363
            if (t->monster) {
                level_place_monster(t->x, t->y, t->monster);
            }
#line 365
            else if (t->text) {
                if (game->message) {
                    land_array_destroy_with_strings(game->message);
                }
#line 368
                game->message = land_split_lines(t->text);
                game->message_tick = game->tick;
            }
#line 370
            else if (t->level) {
                level_set(t->level);
            }
#line 372
            game->trigger++;
        }
#line 372
        else {
#line 374
            break;
        }
    }
}
#line 376
static bool is_dead(Sprite * s) {
    return s->super.x < game->view->scroll_x - 40 || s->health <= 0;
}
static void draw(LandRunner * runner) {
    double scale = land_scale_to_fit(1280, 720, 0);
    if (! load_big_font()) {
        load_fonts(scale);
    }
#line 383
    land_clear(1, 1, 1, 1);
#line 385
    if (reload_font_ticks) {
        reload_font_ticks--;
        if (reload_font_ticks == 0) {
            load_fonts(scale);
        }
    }
#line 390
    land_map_draw(game->map, game->view);
#line 392
    AtlasSheet * sheet = land_array_get_nth(load_get_atlas ()->sheets, 0);
#line 394
    batch_draw(sheet->image);
#line 396
    LandFloat x = land_get_left();
    LandFloat y = land_get_top();
    LandFloat x2 = land_display_width() / land_get_x_scale();
    LandFloat y2 = land_display_height() / land_get_y_scale();
    land_color(0.5, 0.8, 1, 1);
    land_filled_rectangle(x, y, 0, y2);
    land_filled_rectangle(1280, y, x2, y2);
    land_filled_rectangle(0, y, 1280, 0);
    land_filled_rectangle(0, 720, 1280, y2);
#line 406
    {
#line 406
        LandArrayIterator __iter0__ = LandArrayIterator_first(game->kings);
#line 406
        for (King * king = LandArrayIterator_item(game->kings, &__iter0__); LandArrayIterator_next(game->kings, &__iter0__); king = LandArrayIterator_item(game->kings, &__iter0__)) {
            king_draw_target(king, game->view);
        }
    }
#line 409
    if (debug_grid & 1) {
        land_thickness(0);
        land_layer_draw_grid(game->layer, game->view);
    }
    land_font_set(load_small_font());
    land_color(0, 0, 0, 1);
    land_text_pos(0, 0);
    card("Caspar", game->caspar->health, 200, 16, 16, 80, 40, text_color_health);
    card("Melchior", game->melchior->health, 100, 128, 16, 80, 40, text_color_health);
    card("Balthasar", game->balthasar->health, 100, 240, 16, 80, 40, text_color_health);
    card("Gold", game->caspar->score, game->current->gold, 16, 720 - 16 - 60, 80, 40, text_color_gold);
    card("Frankincense", game->melchior->score, game->current->frankincense, 128, 720 - 16 - 60, 80, 40, text_color_gold);
    card("Myrrh", game->balthasar->score, game->current->myrrh, 240, 720 - 16 - 60, 80, 40, text_color_gold);
    card("Level", game->current->id, land_array_count(game->levels) - 1, 1280 - 16 - 80, 720 - 16 - 60, 80, 40, text_color_blue);
#line 424
    if (game->over) {
        char info [100];
        sprintf(info, "Played %ld minutes", game->tick / 60 / 60);
        LandArray * a = land_array_new();
        land_array_add(a, (void *)"Game Over!");
        land_array_add(a, (void *) game->over);
        land_array_add(a, (void *)"Press R to restart");
        land_array_add(a, (void *) info);
        bubble(a, game->over_sprite);
        land_array_destroy(a);
    }
    else if (game->message && game->message_tick > game->tick - 500) {
        bubble(game->message, NULL);
    }
    ui_draw();
#line 440
    draw_bard();
#line 442
    smoke_draw(game->view);
#line 444
    batch_draw(sheet->image);
}
static void draw_bard(void) {
    float bx = game->bardx;
    float by = 0;
    if (bx > 300 + 50 + 300) {
        bx -= 300 + 50 + 300;
        by = 50 - bx;
        bx = 0;
        game->bard->direction = 5;
    }
#line 454
    else if (bx > 300 + 50) {
        bx -= 300 + 50;
        bx = 300 - bx;
        by = 50;
        game->bard->direction = 7;
    }
#line 459
    else if (bx > 300) {
        bx -= 300;
        by += bx;
        bx = 300;
        game->bard->direction = 1;
    }
#line 463
    else {
#line 465
        game->bard->direction = 3;
    }
#line 466
    game->bard->super.x = game->view->scroll_x + 20 + bx;
    game->bard->super.y = 640 + by;
    sprite_draw(game->bard, game->view);
}
static void text_color_gold(int number) {
    land_color(0.5, 0.4, 0.1, 1);
}
static void text_color_blue(int number) {
    land_color(0.5, 0.2, 0.9, 1);
}
static void text_color_health(int number) {
    float r = 0;
    float g = 1;
    float b = 0;
    if (number > 80) {
        float v = (number - 80) / 20.0;
        g = 0.5 + v * 0.2;
    }
#line 483
    else if (number > 60) {
        float v = (number - 60) / 20.0;
        g = 0.5;
        r = 0.5 - v * 0.5;
    }
#line 487
    else if (number > 20) {
        float v = (number - 40) / 40.0;
        r = 1;
        g = v;
    }
#line 490
    else {
#line 492
        float v = (number - 0) / 20.0;
        g = 1 - v;
        b = 1 - v;
        r = 1;
    }
#line 496
    land_color(r, g, b, 1);
}
#line 499
static void card(char const * title, int number, int maximum, int x, int y, int w, int h, void(* text_color_cb)(int x)) {
    float xy [16];
    xy [0] = x;
    xy [1] = y;
    xy [2] = x;
    xy [3] = y + h;
    xy [4] = x + w / 4;
    xy [5] = y + h * 1.25;
    xy [6] = x + w / 4;
    xy [7] = y + h * 1.5;
    xy [8] = x + w * 3 / 4;
    xy [9] = y + h * 1.5;
    xy [10] = x + w * 3 / 4;
    xy [11] = y + h * 1.25;
    xy [12] = x + w;
    xy [13] = y + h;
    xy [14] = x + w;
    xy [15] = y;
#line 518
    land_premul(1, 1, 1, 0.8);
    land_filled_ribbon(8, xy);
    land_color(0, 0, 1, 1);
    land_thickness(2);
    land_ribbon_loop(8, xy);
#line 524
    land_font_set(load_small_font());
#line 526
    land_color(0, 0, 0, 1);
    land_text_pos(x + w / 2, y);
    land_print_center("%s", title);
    text_color_cb(number);
    land_font_set(load_big_font());
    land_print_center("%d", number);
    land_font_set(load_small_font());
    land_print_center("/%d", maximum);
}
static void bubble(LandArray * text, Sprite * who) {
    land_font_set(load_big_font());
    int w = 0;
    {
#line 538
        LandArrayIterator __iter0__ = LandArrayIterator_first(text);
#line 538
        for (char * row = LandArrayIterator_item(text, &__iter0__); LandArrayIterator_next(text, &__iter0__); row = LandArrayIterator_item(text, &__iter0__)) {
            if (w == 0) {
                if (land_starts_with(row, "Caspar")) {
#line 540
                    who = game->caspar;
                }
#line 541
                else if (land_starts_with(row, "Melchior")) {
#line 541
                    who = game->melchior;
                }
#line 542
                else if (land_starts_with(row, "Balthasar")) {
#line 542
                    who = game->balthasar;
                }
#line 543
                else if (! who) {
#line 543
                    who = game->bard;
                }
            }
#line 544
            w = _scramble_max(w, land_text_get_width(row));
        }
    }
#line 546
    int h = land_line_height() * land_array_count(text);
    int x = 1280 / 2 - w / 2;
    int y = 720 / 2 - h / 2;
    x -= 10;
    y -= 10;
    w += 20;
    h += 20;
    float xy [8];
    xy [0] = x;
    xy [1] = y;
    xy [2] = x;
    xy [3] = y + h;
    xy [4] = x + w;
    xy [5] = y + h;
    xy [6] = x + w;
    xy [7] = y;
#line 563
    land_thickness(2);
#line 565
    if (who) {
        float kx, ky;
        land_color(0.5, 0.5, 0, 1);
        land_world_to_view(game->view, who->super.x, who->super.y, & kx, & ky);
        land_line(kx, ky, x + w / 2, y + h / 2);
    }
    land_premul(1, 1, 1, 0.8);
    land_filled_ribbon(4, xy);
    land_color(0.5, 0.5, 0, 1);
    land_ribbon_loop(4, xy);
#line 576
    y += 10;
    land_text_pos(1280 / 2, y);
    land_color(0, 0, 0, 1);
    {
#line 579
        LandArrayIterator __iter0__ = LandArrayIterator_first(text);
#line 579
        for (char * row = LandArrayIterator_item(text, &__iter0__); LandArrayIterator_next(text, &__iter0__); row = LandArrayIterator_item(text, &__iter0__)) {
            land_print_center("%s", row);
        }
    }
}
#line 582
void leave(LandRunner * runner) {
#line 582
    ;
}
#line 585
void destroy(LandRunner * runner) {
    print("Thanks for playing!");
    game_free();
    animation_destroy_all();
    load_unload();
}
LandRunner* game_runner(void) {
    if (_runner) {
#line 592
        return _runner;
    }
#line 593
    _runner = land_runner_new("game", init, enter, tick, draw, leave, destroy);
    land_runner_register(_runner);
    return _runner;
}
/* This file was generated by scramble.py. */
