/* This file was generated by scramble.py. */
#line 1 "src/king.py"
#include "king.h"
#line 13
Sprite* king_new(Animation * animation) {
    King * self;
    land_alloc(self);
    self->super.super.type = & animation->super;
    self->super.health = animation->max_health;
    return & self->super;
}
void king_target(King * self, float x, float y) {
    if (self->target > 1) {
        int t = self->target - 1;
        float dx = x - self->target_x [t - 1];
        float dy = y - self->target_y [t - 1];
        if (dx * dx + dy * dy > 40 * 40) {
            self->target_x [t] = x;
            self->target_y [t] = y;
            if (self->target < 100) {
                self->target++;
            }
        }
    }
#line 29
    else {
#line 31
        if (! self->target) {
            self->target_x [0] = x;
            self->target_y [0] = y;
        }
#line 34
        self->target = 2;
    }
#line 35
    self->target_x [self->target - 1] = x;
    self->target_y [self->target - 1] = y;
}
void king_move(Sprite * self) {
    LandSprite * super = & self->super;
    King * king = (void *) self;
    Animation * animation = (void *) super->type;
    Game * game = game_global();
    LandFloat dx = 0.5 + self->ex / 2;
    LandFloat dy = 0 + self->ey / 2;
    self->ex = 0;
    self->ey = 0;
#line 48
    if (king->target > 0) {
        LandFloat tx = king->target_x [0] - super->x;
        LandFloat ty = king->target_y [0] - super->y;
        if (tx + super->x < game->view->scroll_x + 40) {
            tx = game->view->scroll_x + 40 - super->x;
        }
#line 53
        LandFloat d = sqrt(tx * tx + ty * ty);
        if (d > 5 + king->extra_target_radius) {
            dx += animation->movement * tx / d;
            dy += animation->movement * ty / d;
        }
#line 56
        else {
#line 58
            king->extra_target_radius = 0;
            // 3: 0 1 2
            king->target--;
            // 2: 0 1
            memmove(king->target_x, king->target_x + 1, king->target * sizeof (float));
            memmove(king->target_y, king->target_y + 1, king->target * sizeof (float));
            // 2: 1 2
            if (self == game->balthasar) {
                sprite_heal(self, 20);
            }
        }
#line 67
        sprite_direction(self, tx, ty);
    }
#line 67
    else {
#line 69
        if (super->x < game->view->scroll_x + 40) {
            dx += animation->movement;
        }
#line 71
        sprite_direction(self, 1, 0);
    }
    land_sprite_move(super, game->grid, dx, dy);
    LandList * cl = land_sprites_grid_overlap(super, game->grid);
    if (cl) {
        LandFloat cx = 0;
        LandFloat cy = 0;
        int n = 0;
        {
#line 79
            LandListIterator __iter0__ = LandListIterator_first(cl);
#line 79
            for (LandSprite * cs = LandListIterator_item(cl, &__iter0__); LandListIterator_next(cl, &__iter0__); cs = LandListIterator_item(cl, &__iter0__)) {
                Sprite * sprite = (void *) cs;
                int item = 0;
                int monster = 0;
                if (cs->type == (void *) game->coin) {
#line 83
                    item = 1;
                }
#line 84
                if (cs->type == (void *) game->frankincense) {
#line 84
                    item = 2;
                }
#line 85
                if (cs->type == (void *) game->myrrh) {
#line 85
                    item = 3;
                }
#line 86
                if (cs->type == (void *) game->krampus) {
#line 86
                    monster = 1;
                }
#line 87
                if (cs->type == (void *) game->boar) {
#line 87
                    monster = 2;
                }
#line 88
                if (cs->type == (void *) game->grizzly) {
#line 88
                    monster = 3;
                }
#line 89
                if (cs->type == (void *) game->wolf) {
#line 89
                    monster = 4;
                }
                if (sprite == game->balthasar) {
                    sprite_heal(self, 20);
                }
                if (self == game->caspar) {
                    if (item == 1) {
#line 95
                        pick_up(self, cs);
                    }
#line 96
                    Animation * smash = NULL;
                    int tree = 0;
                    for (int tt = 1; tt < 7; tt += 1) {
                        if (cs->type == (& game->trees [tt]->super)) {
                            tree = 1;
                            if (tt != 1 && tt != 4) {
                                smash = game->trees [tt - 1];
                            }
                        }
                    }
#line 103
                    if (tree && game->tick > sprite->tick_cast + 10 + king->exhausted) {
                        play_swoosh();
                        sprite->tick_cast = game->tick;
                        self->health -= 1;
                        king->exhausted += 10;
                        for (int si = 0; si < 10; si += 1) {
#line 110
                            smoke_add(cs->x + land_rnd(- 6, 6), cs->y + land_rnd(- 3, 3));
                        }
#line 111
                        if (smash) {
                            cs->type = & smash->super;
                        }
#line 112
                        else {
#line 114
                            land_sprite_hide(cs, game->grid);
                        }
                    }
                }
#line 116
                if (self == game->melchior) {
                    if (item == 2) {
#line 117
                        pick_up(self, cs);
                    }
#line 118
                    if (monster) {
                        king_slay(self, sprite);
                    }
                }
#line 121
                if (self == game->balthasar) {
                    if (item == 3) {
#line 122
                        pick_up(self, cs);
                    }
#line 123
                    if (sprite == game->caspar || sprite == game->melchior) {
                        sprite_heal(sprite, 20);
                    }
                }
#line 125
                if (item) {
                    continue;
                }
#line 127
                float ax, ay;
                float bx = cs->x - super->x;
                float by = cs->y - super->y;
                float b = land_norm2d(bx, by);
                land_ortho2d(bx, by, & ax, & ay);
                float dot = land_dot2d(dx, dy, ax, ay);
                float aa = land_dot2d(ax, ay, ax, ay);
                if (aa > 1) {
                    cx += ax * dot / aa;
                    cy += ay * dot / aa / 2;
                }
                // also move away a little bit
                if (b > 1) {
                    cx -= bx / b / 4;
                    cy -= by / b / 4;
                }
                sprite->ex += bx / b;
                sprite->ey += by / b;
#line 146
                n++;
            }
        }
#line 147
        land_list_destroy(cl);
        if (n) {
            land_sprite_move(super, game->grid, - dx, - dy);
            king->extra_target_radius += 5;
            cx /= n;
            cy /= n;
            land_sprite_move(super, game->grid, cx, cy);
            cl = land_sprites_grid_overlap(super, game->grid);
            if (cl) {
                land_sprite_move(super, game->grid, - cx, - cy);
                land_list_destroy(cl);
            }
#line 158
            self->blocked++;
            if (self->blocked > 120) {
                king->target = 0;
            }
        }
    }
#line 160
    else {
#line 162
        self->blocked = 0;
        if (king->exhausted) {
            king->exhausted -= 1;
        }
    }
}
#line 166
void king_slay(Sprite * king, Sprite * monster) {
    Game * game = game_global();
    if (game->tick > monster->tick_cast + 30) {
        play_swoosh();
        monster->health -= 50;
        monster->prey = king;
        monster->blocked = 60 * 10;
        monster->tick_cast = game->tick;
        for (int si = 0; si < 10; si += 1) {
#line 176
            smoke_add_blood(monster->super.x + land_rnd(- 6, 6), monster->super.y + land_rnd(- 3, 3));
        }
    }
}
#line 178
void pick_up(Sprite * self, LandSprite * item) {
    play_ding();
    Game * game = game_global();
    self->score++;
    land_sprite_hide(item, game->grid);
    for (int si = 0; si < 20; si += 1) {
        smoke_add_firework(item->x, item->y);
    }
}
#line 186
void king_draw_target(King * self, LandView * view) {
    float ax, ay;
    land_world_to_view(view, self->super.super.x, self->super.super.y, & ax, & ay);
    for (int t = 0; t < self->target; t += 1) {
        float bx, by;
        land_world_to_view(view, self->target_x [t], self->target_y [t], & bx, & by);
        land_premul(1, 1, 0, 0.5);
        land_thickness(16);
        land_line(ax, ay, bx, by);
        ax = bx;
        ay = by;
    }
}
/* This file was generated by scramble.py. */
