/* This file was generated by scramble.py. */
#line 1 "src/level.py"
#include "level.h"
static Trigger* trigger_add(int x, int y, char const * text, Animation * monster, int level);
static Trigger* trigger(int x, int y, char const * text, Animation * monster);
static Sprite* random_tree(void);
static Sprite* random_gift(int r);
static bool move_with_offset2(Sprite * s, int x, int y, float o, int tn, float ymin, float ymax);
static bool move_with_offset(Sprite * s, int x, int y, float o, int tn);
static bool remove_if_overlap(Sprite * s);
static void level(int x, int w);
static void done(void);
static void place_gift(int x, int y, int r);
static void clear_all_trees(int x, int y, int radius);
static Sprite* new_sprite(Animation * animation, float x, float y);
#line 3
static int lx = 10;
static int level_width;
#line 6
void level_create(void) {
    Game * game = game_global();
    game->levels = land_array_new();
    land_array_add(game->levels, NULL) /* entry 0 */;
    lx = 0;
    level_width = 0;
#line 13
    level1(65);
    level2(100);
    level3(100);
    level4(100);
    level5(100);
    level6(100);
    level7(100);
    level8(100);
    level9(100);
    level10(100);
    level11(100);
    level12(100);
    level13(100);
#line 27
    level_set(1);
}
void level_set(int x) {
    Game * game = game_global();
    game->current = land_array_get_nth(game->levels, x);
    game->caspar->score = 0;
    game->melchior->score = 0;
    game->balthasar->score = 0;
    print("level %d (gold: %d)", x, game->current->gold);
}
#line 38
static Trigger* trigger_add(int x, int y, char const * text, Animation * monster, int level) {
    Game * game = game_global();
    Trigger * self;
    land_alloc(self);
    self->x = x;
    self->y = y;
    self->text = text;
    self->monster = monster;
    self->level = level;
    int i = land_array_count(game->triggers);
    int j = i - 1;
    land_array_add(game->triggers, self);
    while (j >= 0) {
        Trigger * last = land_array_get_nth(game->triggers, j);
        if (self->x < last->x) {
            land_array_swap(game->triggers, j, i);
            i = j;
        }
#line 54
        else {
#line 56
            break;
        }
#line 57
        j--;
    }
    return self;
}
static Trigger* trigger(int x, int y, char const * text, Animation * monster) {
    return trigger_add(x, y, text, monster, 0);
}
static Sprite* random_tree(void) {
    Game * game = game_global();
    int r = land_rand(0, 99);
    int tt = 0;
    if (r < 1) {
#line 68
        tt = 2;
    }
#line 69
    else if (r < 2) {
#line 69
        tt = 5;
    }
#line 70
    else if (r < 60) {
#line 70
        tt = 3;
    }
#line 70
    else {
        tt = 6;
    }
#line 72
    Sprite * s = new_sprite(game->trees [tt], 0, 0);
    s->frame = land_rand(0, 7);
    return s;
}
static Sprite* random_gift(int r) {
    Game * game = game_global();
    if (r == 0) {
        r = land_rand(0, 2);
    }
#line 79
    else {
#line 81
        r -= 1;
    }
#line 82
    Animation * a = NULL;
    if (r == 0) {
#line 83
        a = game->coin;
    }
#line 84
    if (r == 1) {
#line 84
        a = game->frankincense;
    }
#line 85
    if (r == 2) {
#line 85
        a = game->myrrh;
    }
#line 86
    Sprite * s = new_sprite(a, 0, 0);
    s->frame = land_rand(0, 31);
    return s;
}
#line 91
static bool move_with_offset2(Sprite * s, int x, int y, float o, int tn, float ymin, float ymax) {
    float o0 = o;
    for (int t = 0; t < tn; t += 1) {
        float xoff = land_rnd(- o, o);
        float yoff = land_rnd(- o / 2, o / 2);
        float xp = x * 40 + xoff;
        float yp = y * 20 + yoff;
        if (yp < ymin) {
#line 98
            yp = ymin;
        }
#line 99
        if (yp > ymax) {
#line 99
            yp = ymax;
        }
#line 100
        land_sprite_move_to(& s->super, game_global ()->grid, xp, yp);
        if (! remove_if_overlap(s)) {
            return 1;
        }
#line 103
        o = o0 + o0 * 2 * t / tn;
    }
#line 104
    land_sprite_destroy(& s->super);
    return 0;
}
static bool move_with_offset(Sprite * s, int x, int y, float o, int tn) {
    return move_with_offset2(s, x, y, o, tn, 0, 720);
}
static bool remove_if_overlap(Sprite * s) {
    Game * game = game_global();
    LandList * cl = land_sprites_grid_overlap(& s->super, game->grid);
    if (cl) {
        land_sprite_remove_from_grid(& s->super, game->grid);
        land_list_destroy(cl);
        return 1;
    }
#line 117
    return 0;
}
static void level(int x, int w) {
    Game * game = game_global();
    if (game->current) {
        done();
    }
#line 123
    level_width = w;
    land_alloc(game->current);
    game->current->id = x;
    game->current->x = lx;
    land_array_add(game->levels, game->current);
    trigger_add(lx, 0, NULL, NULL, x);
}
static void done(void) {
    Game * game = game_global();
    int lw = level_width;
    for (int i = 0; i < 10; i += 1) {
        int x = lx + lw - 10 + land_rand(- 10, 10);
        int y = land_rand(10, 25);
        trigger(x, y, NULL, game->sheep);
    }
#line 137
    trigger(lx + lw - 10, 18, NULL, game->shepherd);
#line 139
    lx += lw;
}
void level1(int lw) {
    level(1, lw);
    trigger(32, 0, "I'm the ukulele playing narrator bard.\nI also have a bag of fireworks\nand light them with my lighter for no reason!", NULL);
    trigger(40, 0, "The three holy mages:\nBalthasar King of Babylon,\nMelchior King of Persia\nand Caspar King of India", NULL);
    trigger(47, 0, "Balthasar:\nThe star shines clear upon the sky!\nWe must make haste!", NULL);
    trigger (51, 0, "Melchior:\nMy steed is the fastest in all of Persia!", NULL)->special = "steed";
    trigger(54, 0, "Caspar:\nHey guys wait for me!", NULL);
    trigger(57, 0, "Caspar the Strong rides on an elephant.\nHe can tear down trees!", NULL);
    trigger(60, 0, "Melchior the Swift rides on a horse.\nHe can battle foes!", NULL);
    trigger(63, 0, "Balthasar the Wise rides on a camel.\nHe's good at first aid!", NULL);
    for (int x = lx; x < lx + lw; x += 3) {
        Sprite * s = random_tree();
        int y = land_rand(0, 35);
        move_with_offset(s, x, y, 20, 1);
    }
}
#line 156
void level2(int lw) {
    level(2, lw);
    trigger(lx, 0, "Caspar needs\nall the Gold!", NULL);
    trigger(lx + 5, 0, "Melchior needs\nall the Frankincense!", NULL);
    trigger(lx + 10, 0, "Balthasar needs\nall the Myrrh!", NULL);
    trigger(lx + 50, 0, "If you don't like my music press\n>> m <<\nto silence it", NULL);
    trigger(lx + 60, 0, "You can always pause by pressing\n>> p <<", NULL);
    for (int x = lx; x < lx + lw; x += 1) {
        Sprite * s = random_tree();
        int y = land_rand(0, 35);
        move_with_offset(s, x, y, 20, 1);
    }
#line 167
    for (int x = lx; x < lx + lw - 32; x += 10) {
        place_gift(x, land_rand(2, 33), 1 + ((x - lx) / 10) % 3);
    }
}
#line 170
void level3(int lw) {
    level(3, lw);
    trigger(lx, 0, "Balthasar: Methinks I spot a wild boar!", NULL);
    trigger(lx + 4, 0, "Melchior: Haha, are you afraid of boars?", NULL);
    Game * game = game_global();
    for (int x = lx; x < lx + lw; x += 1) {
        Sprite * s = random_tree();
        int y = land_rand(0, 35);
        move_with_offset(s, x, y, 20, 1);
    }
    for (int x = lx + 5; x < lx + lw - 32; x += 10) {
        int y = land_rand(2, 33);
        place_gift(x, y, 0);
        trigger(x, y, NULL, game->boar);
    }
}
#line 185
void level4(int lw) {
    Game * game = game_global();
    level(4, lw);
    trigger(lx, 0, "Balthasar: Let's take the forest path!", NULL);
    trigger(lx + 4, 0, "Caspar: I don't care about trees", NULL);
#line 191
    for (int y = 0; y < 36; y += 1) {
        for (int x = lx; x < lx + lw; x += 1) {
            int r = land_rand(0, 99);
            if (r >= 33) {
                continue;
            }
#line 196
            Sprite * s = random_tree();
            move_with_offset(s, x, y, 20, 10);
        }
    }
#line 199
    for (int x = lx; x < lx + lw; x += 1) {
        clear_all_trees(x, 18, 100);
        if (x > lx + 5 && x < lx + lw - 32) {
            if (land_rnd(0, 1) < 0.1) {
                place_gift(x, 18, 0);
                trigger(x, 18, NULL, game->boar);
            }
        }
    }
}
#line 206
void level5(int lw) {
    Game * game = game_global();
    level(5, lw);
    trigger(lx, 0, "Balthasar: Where does this path lead?", NULL);
#line 211
    for (int y = 0; y < 36; y += 1) {
        for (int x = lx; x < lx + lw; x += 1) {
            int r = land_rand(0, 99);
            if (r >= 33) {
                continue;
            }
#line 216
            Sprite * s = random_tree();
            move_with_offset(s, x, y, 20, 10);
        }
    }
#line 219
    int y = 18;
    int dy = 1;
    for (int x = lx; x < lx + lw; x += 1) {
        clear_all_trees(x, y, 40);
        y += dy;
        if (y < 5) {
#line 224
            dy = 1;
        }
#line 225
        if (y > 30) {
#line 225
            dy = - 1;
        }
        if (x > lx + 5 && x < lx + lw - 32) {
            if (land_rnd(0, 1) < 0.1) {
                place_gift(x, y, 0);
                trigger(x, y, NULL, game->boar);
            }
        }
    }
}
#line 232
void level6(int lw) {
    Game * game = game_global();
    level(6, lw);
    trigger(lx, 0, "Balthasar: That... that... sounded like a bear!", NULL);
    trigger(lx + 4, 0, "Melchior: Haha let them come!", NULL);
#line 238
    for (int y = 0; y < 36; y += 1) {
        for (int x = lx; x < lx + lw; x += 1) {
            int r = land_rand(0, 99);
            if (r >= 33) {
                continue;
            }
#line 243
            Sprite * s = random_tree();
            move_with_offset(s, x, y, 20, 10);
        }
    }
#line 246
    int y = 18;
    int s = 40;
    int dy = 1;
    int ds = 0;
    for (int x = lx; x < lx + lw; x += 1) {
        clear_all_trees(x, y, s);
        y += dy * land_rand(0, 3);
        if (y < 5) {
#line 253
            dy = 1;
        }
#line 254
        if (y > 30) {
#line 254
            dy = - 1;
        }
#line 255
        s += ds;
        if (s > 100) {
#line 256
            ds = - 1;
        }
#line 257
        if (s < 20) {
#line 257
            ds = 1;
        }
        if (x > lx + 5 && x < lx + lw - 32) {
            if (land_rnd(0, 1) < 0.1) {
                place_gift(x, y, 0);
                trigger(x, y, NULL, game->boar);
            }
#line 263
            if (land_rnd(0, 1) < 0.1) {
                place_gift(x, y, 0);
                trigger(x, y, NULL, game->grizzly);
            }
        }
    }
}
#line 267
void level7(int lw) {
    Game * game = game_global();
    level(7, lw);
    trigger(lx, 0, "Balthasar: By god! We are lost!", NULL);
    trigger(lx + 3, 0, "Caspar: We should go back home\nToo many trees here", NULL);
    trigger(lx + 6, 0, "Melchior: And too much snow\nAnd too many monsters...", NULL);
#line 274
    for (int y = 0; y < 36; y += 1) {
        for (int x = lx + 6; x < lx + lw; x += 1) {
            int r = land_rand(0, 99);
            if (r >= 20) {
                continue;
            }
#line 279
            Sprite * s = random_tree();
            move_with_offset(s, x, y, 20, 10);
        }
    }
#line 282
    for (int x = lx; x < lx + lw; x += 1) {
        int y = land_rand(5, 30);
#line 285
        if (x > lx + 9 && x < lx + lw - 32) {
            if (land_rnd(0, 1) < 0.05) {
                clear_all_trees(x, y, 40);
                place_gift(x, y, 0);
                trigger(x, y, NULL, game->boar);
            }
#line 290
            if (land_rnd(0, 1) < 0.05) {
                trigger(x, y, NULL, game->grizzly);
                clear_all_trees(x, y, 40);
                place_gift(x, y, 0);
            }
        }
    }
}
#line 295
void level8(int lw) {
    Game * game = game_global();
    level(8, lw);
    trigger(lx, 0, "Balthasar: Behold!\nThe trees are getting lighter", NULL);
#line 300
    for (int y = 0; y < 36; y += 1) {
        for (int x = lx; x < lx + lw; x += 1) {
            int r = land_rand(0, 99);
            if (r >= 20 - 20 * (x - lx) / lw) {
                continue;
            }
#line 305
            Sprite * s = random_tree();
            move_with_offset(s, x, y, 20, 10);
        }
    }
#line 308
    clear_all_trees(lx - 28, 18, 80);
#line 310
    for (int x = lx; x < lx + lw; x += 1) {
        int y = land_rand(5, 30);
#line 313
        if (x > lx + 5 && x < lx + lw - 32) {
            if (land_rnd(0, 1) < 0.05) {
                trigger(x, y, NULL, game->boar);
                clear_all_trees(x, y, 40);
                place_gift(x, y, 0);
            }
#line 318
            if (land_rnd(0, 1) < 0.05) {
                trigger(x, y, NULL, game->grizzly);
                clear_all_trees(x, y, 40);
                place_gift(x, y, 0);
            }
        }
    }
}
#line 324
void level9(int lw) {
    Game * game = game_global();
    level(9, lw);
    trigger(lx, 0, "Balthasar: What is this growling noise?", NULL);
#line 329
    for (int y = 0; y < 36; y += 1) {
        for (int x = lx; x < lx + lw; x += 1) {
            int r = land_rand(0, 99);
            if (r >= 20 - 20 * (x - lx) / lw) {
                continue;
            }
#line 334
            Sprite * s = random_tree();
            move_with_offset(s, x, y, 20, 10);
        }
    }
#line 337
    clear_all_trees(lx - 28, 18, 80);
#line 339
    for (int x = lx; x < lx + lw; x += 1) {
        int y = land_rand(5, 30);
#line 342
        if (x > lx + 5 && x < lx + lw - 32) {
            if (land_rnd(0, 1) < 0.1) {
                trigger(x, y, NULL, game->grizzly);
                clear_all_trees(x, y, 40);
                place_gift(x, y, 0);
            }
#line 347
            if (land_rnd(0, 1) < 0.1) {
                trigger(x, y, NULL, game->grizzly);
                clear_all_trees(x, y, 40);
            }
        }
#line 351
        if ((x - lx) % 20 == 0 && x > lx + 20) {
            for (y = 5; y < 31; y += 6) {
                trigger(x, y, NULL, game->boar);
            }
        }
    }
}
#line 355
void level10(int lw) {
    Game * game = game_global();
#line 358
    level(10, lw);
#line 360
    for (int x = lx; x < lx + lw; x += 1) {
        int y = land_rand(0, 35);
        Sprite * s = random_tree();
        move_with_offset(s, x, y, 20, 10);
    }
    trigger(lx, 0, "Balthasar: Did you hear that?\nSomething evil lurks ahead", NULL);
#line 367
    trigger(lx + 10, 0, "Melchior: It's the Krampus!\nWe are doomed!", NULL);
    trigger(lx + 10, 18, NULL, game->krampus);
}
void level11(int lw) {
    Game * game = game_global();
    level(11, lw);
    trigger(lx, 0, "Balthasar: What will be next?", NULL);
    trigger(lx + 5, 0, "Melchior: I can hear something howling...", NULL);
    trigger(lx + 9, 0, "Caspar: We should turn around while we can!", NULL);
    for (int x = lx; x < lx + lw; x += 1) {
        int y = land_rand(0, 35);
        Sprite * s = random_tree();
        move_with_offset(s, x, y, 20, 10);
    }
    for (int i = 0; i < 8; i += 1) {
        int x = lx + 10 + i * (lw - 10 - 32) / 8;
        int y = land_rand(10, 25);
        for (int j = 0; j < 15; j += 1) {
            Sprite * s = random_tree();
#line 387
            move_with_offset(s, x + land_rand(- 10, 10), y + land_rand(- 10, 10), 20, 10);
        }
#line 388
        int n = land_rand(2, 4);
        for (int j = 0; j < n; j += 1) {
            trigger(x + land_rand(- 5, 5), y + land_rand(- 5, 5), NULL, game->wolf);
        }
#line 391
        for (int j = 0; j < 2; j += 1) {
            place_gift(x, y, 0);
        }
    }
}
#line 394
void level12(int lw) {
    Game * game = game_global();
    level(12, lw);
    trigger(lx, 0, "Balthasar: Will this never end?", NULL);
    for (int x = lx; x < lx + lw; x += 1) {
        int y = land_rand(0, 35);
        Sprite * s = random_tree();
        move_with_offset(s, x, y, 20, 10);
    }
    for (int i = 0; i < 4; i += 1) {
        int x = lx + 10 + i * (lw - 10 - 32) / 4;
        int y = land_rand(10, 25);
        for (int j = 0; j < 15; j += 1) {
            Sprite * s = random_tree();
#line 409
            move_with_offset(s, x + land_rand(- 10, 10), y + land_rand(- 10, 10), 20, 10);
        }
#line 410
        int n = land_rand(5, 10);
        for (int j = 0; j < n; j += 1) {
            trigger(x + land_rand(- 5, 5), y + land_rand(- 5, 5), NULL, game->boar);
        }
#line 413
        if (i != 0) {
            trigger(x + land_rand(- 5, 5), y + land_rand(- 5, 5), NULL, game->wolf);
        }
#line 415
        trigger(x + land_rand(- 5, 5), y + land_rand(- 5, 5), NULL, game->grizzly);
        if (i == 3) {
            trigger(x + land_rand(- 5, 5), y + land_rand(- 5, 5), NULL, game->krampus);
        }
#line 417
        else {
#line 419
            trigger(x + land_rand(- 5, 5), y + land_rand(- 5, 5), NULL, game->grizzly);
        }
        for (int j = 0; j < 2; j += 1) {
            place_gift(x, y, 0);
        }
    }
}
#line 424
void level13(int lw) {
    Game * game = game_global();
    level(13, lw);
    trigger(lx, 0, "And so the three kings continue their journey...", NULL);
#line 429
    for (int x = lx; x < lx + lw; x += 1) {
        int y = land_rand(0, 35);
        Sprite * s = random_tree();
        move_with_offset(s, x, y, 20, 10);
    }
    clear_all_trees(lx, 18, 120);
    Sprite * s = new_sprite(game->logcabin, lx * 40, 18 * 20);
    s->frame = 1;
}
static void place_gift(int x, int y, int r) {
    Game * game = game_global();
    Sprite * s = random_gift(r);
    if (move_with_offset2(s, x, y, 20, 10, 20, 700)) {
        if (s->super.type == (& game->coin->super)) {
#line 442
            game->current->gold++;
        }
#line 443
        if (s->super.type == (& game->frankincense->super)) {
#line 443
            game->current->frankincense++;
        }
#line 444
        if (s->super.type == (& game->myrrh->super)) {
#line 444
            game->current->myrrh++;
        }
    }
}
#line 446
static void clear_all_trees(int x, int y, int radius) {
    Game * game = game_global();
#line 449
    LandList * l = land_sprites_grid_get_circle(game->grid, x * 40, y * 20, radius);
    if (l) {
        {
#line 451
            LandListIterator __iter0__ = LandListIterator_first(l);
#line 451
            for (LandSprite * s = LandListIterator_item(l, &__iter0__); LandListIterator_next(l, &__iter0__); s = LandListIterator_item(l, &__iter0__)) {
                for (int tt = 1; tt < 7; tt += 1) {
                    if (s->type == (& game->trees [tt]->super)) {
                        land_sprite_remove_from_grid(s, game->grid);
                        land_sprite_destroy(s);
                        break;
                    }
                }
            }
        }
#line 457
        land_list_destroy(l);
    }
}
#line 459
void level_place_monster(int x, int y, Animation * monster) {
    Game * game = game_global();
    Sprite * s = new_sprite(monster, x * 40, y * 20);
    Animation * a = (void *) s->super.type;
    if (a->bite == 0) {
        if (! move_with_offset2(s, x, y, 20, 10, 20, 700)) {
#line 464
            return ;
        }
    }
#line 466
    land_array_add(game->monsters, s);
}
static Sprite* new_sprite(Animation * animation, float x, float y) {
    Game * game = game_global();
    Sprite * sprite = sprite_new(animation);
    land_sprite_place_into_grid(& sprite->super, game->grid, x, y);
    return sprite;
}
/* This file was generated by scramble.py. */
