/* This file was generated by scramble.py. */
#line 1 "src/load.py"
#include "load.h"
static void load(char const * name, float movement, float radius);
static void not_continuous(void);
static void directional(void);
static void stationary(void);
static void bite(int x);
static void health(int x);
static void around(void);
static void frames(int a);
#line 5
LandHash * animation_by_name;
Atlas * atlas;
Animation * last;
LandFont * small_font;
LandFont * big_font;
int next_frames = 5;
LandSound * ding;
LandSound * swoosh;
LandSound * ugh;
LandSound * bells;
#line 16
static void load(char const * name, float movement, float radius) {
#line 18
    Animation * a = animation_new(atlas, name, next_frames, movement, radius);
    next_frames = 5;
    last = a;
    a->continuous = 1;
    a->max_health = 100;
    land_hash_insert(animation_by_name, name, a);
}
static void not_continuous(void) {
#line 25
    last->continuous = 0;
}
#line 26
static void directional(void) {
#line 26
    last->directional = 1;
}
#line 27
static void stationary(void) {
#line 27
    last->stationary = 1;
}
#line 28
static void bite(int x) {
#line 28
    last->bite = x;
}
#line 29
static void health(int x) {
#line 29
    last->max_health = x;
}
#line 30
static void around(void) {
#line 30
    last->around = 1;
}
#line 31
static void frames(int a) {
#line 31
    next_frames = a;
}
Atlas* load_get_atlas(void) {
    return atlas;
}
void load_atlas(void) {
    atlas = atlas_new("data/atlas.txt");
#line 39
    animation_by_name = land_hash_new();
    load("caspar", 1, 25);
#line 40
    directional();
#line 40
    health(200);
    load("melchior", 2, 15);
#line 41
    directional();
    load("balthasar", 1.5, 20);
#line 42
    directional();
    load("bard", 1.5, 20);
#line 43
    directional();
    load("wolf", 1.1, 10);
#line 44
    directional();
#line 44
    bite(20);
    load("sheep", 0.3, 10);
#line 45
    directional();
    load("shepherd", 0.3, 10);
#line 46
    directional();
    load("pine", 0, 32);
    load("pine_dead", 0, 32);
    load("pine_fallen", 0, 32);
#line 49
    not_continuous();
    load("spruce", 0, 32);
    load("spruce_dead", 0, 32);
    load("spruce_fallen", 0, 32);
#line 52
    not_continuous();
    load("grizzly", 0.7, 20);
#line 53
    directional();
#line 53
    bite(20);
#line 53
    health(200);
    load("boar", 1, 10);
#line 54
    directional();
#line 54
    bite(10);
    load("krampus", 0.8, 30);
#line 55
    directional();
#line 55
    bite(40);
#line 55
    health(1000);
    frames(32);
#line 56
    load("coin", 0, 25);
#line 56
    around();
    frames(32);
#line 57
    load("myrrh", 0, 25);
#line 57
    around();
    frames(32);
#line 58
    load("frankincense", 0, 25);
#line 58
    around();
    frames(1);
#line 59
    load("logcabin", 0, 40);
#line 59
    stationary();
#line 61
    ding = land_sound_load("data/ding.ogg");
    swoosh = land_sound_load("data/swoosh.ogg");
    ugh = land_sound_load("data/ugh.ogg");
    bells = land_sound_load("data/bells.ogg");
}
void load_unload(void) {
    atlas_destroy(atlas);
    atlas = NULL;
}
Animation* load_animation(char const * name) {
    return land_hash_get(animation_by_name, name);
}
AtlasSprite* load_picture(char const * name) {
    return atlas_load_picture(atlas, name);
}
void load_fonts(double scale) {
    if (small_font) {
#line 77
        land_font_destroy(small_font);
    }
#line 78
    if (big_font) {
#line 78
        land_font_destroy(big_font);
    }
#line 79
    double s = scale;
    small_font = land_font_load("data/JosefinSans-Regular.ttf", 16 * s);
    land_font_scale(small_font, 1.0 / s);
    big_font = land_font_load("data/JosefinSans-Regular.ttf", 32 * s);
    land_font_scale(big_font, 1.0 / s);
}
LandFont* load_big_font(void) {
#line 85
    return big_font;
}
#line 86
LandFont* load_small_font(void) {
#line 86
    return small_font;
}
void play_ding(void) {
#line 88
    land_sound_play(ding, 1, 0, 1);
}
#line 89
void play_swoosh(void) {
#line 89
    land_sound_play(swoosh, 1, 0, 1);
}
#line 90
void play_ugh(void) {
#line 90
    land_sound_play(ugh, 1, 0, 1);
}
#line 91
void play_bells(void) {
#line 91
    land_sound_play(bells, 1, 0, 1);
}
/* This file was generated by scramble.py. */
