/* This file was generated by scramble.py. */
#line 1 "src/smoke.py"
#include "smoke.h"
#line 18
static Smoke * smoke;
#line 20
void smoke_init(void) {
    land_alloc(smoke);
    smoke->particles = land_array_new();
    for (int i = 0; i < 256; i += 1) {
        Particle * p;
        land_alloc(p);
        land_array_add(smoke->particles, p);
    }
    smoke->smoke_pic = load_picture("smoke.png");
}
Particle* smoke_add(float x, float y) {
    int i = smoke->active;
    if (i >= land_array_count(smoke->particles)) {
        return NULL;
    }
#line 34
    smoke->active++;
    Particle * p = land_array_get_nth(smoke->particles, i);
    p->x = x;
    p->y = y;
    p->t = 0;
    p->dx = 0;
    p->dy = - 1;
    float c = land_rnd(0.1, 0.5);
    p->r = c;
    p->g = c;
    p->b = c;
    p->a = 0.5;
    p->s = land_rnd(0.1, 0.5);
    p->kind = 0;
    p->t = 120;
    return p;
}
Particle* smoke_add_blood(float x, float y) {
    Particle * p = smoke_add(x, y);
    if (! p) {
        return NULL;
    }
#line 55
    p->r = 1;
    p->g = 0;
    p->b = 0;
    p->s *= 0.2;
    p->kind = 1;
    p->t = 80;
    return p;
}
Particle* smoke_add_spark(float x, float y) {
    Particle * p = smoke_add(x, y);
    if (! p) {
        return NULL;
    }
#line 67
    p->r = 0.2;
    p->g = 1;
    p->b = 0.5;
    p->a = 1;
    p->s = 0.1;
    p->kind = 2;
    float a = land_rnd(0, 2 * pi);
    p->dx = cos(a) * 2;
    p->dy = sin(a) * 2;
    p->t = 40;
    return p;
}
Particle* smoke_add_firework(float x, float y) {
    Particle * p = smoke_add(x, y);
    if (! p) {
        return NULL;
    }
#line 83
    p->r = land_rand(2, 4) / 2.0;
    p->g = 1;
    p->b = 0;
    p->a = 1;
    p->s = 0.1;
    p->kind = 3;
    float a = land_rnd(0, 2 * pi);
    p->dx = cos(a) * p->r;
    p->dy = (- 2 + sin(a)) * p->r;
    p->t = 80;
    return p;
}
void particle_tick(Particle * self) {
    self->t--;
    self->y += self->dy;
    self->x += self->dx;
    if (self->kind == 3) {
        self->g -= 1 / 80.0;
        self->dy += 0.1 * self->r;
    }
#line 102
    else if (self->kind == 2) {
#line 102
        ;
    }
    else if (self->kind == 1) {
        self->dy += land_rnd(0, 0.05);
        self->dx += land_rnd(- 0.05, 0.05);
        if (self->r > 0.5) {
#line 107
            self->r -= 0.01;
        }
    }
#line 107
    else {
#line 109
        float c = self->r + land_rnd(0, 0.01);
        if (c > 1) {
            c = 1;
        }
#line 112
        self->r = c;
        self->g = c;
        self->b = c;
        self->a -= 0.5 / 120;
        self->dx += land_rnd(- 0.1, + 0.1);
        if (self->a < 0) {
            self->a = 0;
        }
#line 119
        self->s += 0.5 / 120;
        if (self->s > 1) {
            self->s = 1;
        }
    }
}
#line 123
void particle_draw(Particle * self, LandView * view) {
    float x = self->x - view->scroll_x;
    float y = self->y - view->scroll_y;
    AtlasSprite * s = smoke->smoke_pic;
    //land_image_clip(s.sheet->image, s.x, s.y, s.x + s.w, s.y + s.h)
    //land_push_transform()
    //land_translate(x, y)
    //land_scale(self.s, self.s)
    //land_translate(s.ox - s.x - 64, s.oy - s.y - 64)
    //land_image_draw_tinted(s.sheet->image, 0, 0,
    //    self.r * self.a, self.g * self.a, self.b * self.a, self.a)
    //land_pop_transform()
#line 136
    batch_add_tint((s->ox - 64) * self->s + x, (s->oy - 64 + s->h) * self->s + y, s->x, s->y + s->h, self->r * self->a, self->g * self->a, self->b * self->a, self->a);
    batch_add_tint((s->ox - 64 + s->w) * self->s + x, (s->oy - 64 + s->h) * self->s + y, s->x + s->w, s->y + s->h, self->r * self->a, self->g * self->a, self->b * self->a, self->a);
    batch_add_tint((s->ox - 64) * self->s + x, (s->oy - 64) * self->s + y, s->x, s->y, self->r * self->a, self->g * self->a, self->b * self->a, self->a);
    batch_add_tint_tri((s->ox - 64 + s->w) * self->s + x, (s->oy - 64) * self->s + y, s->x + s->w, s->y, self->r * self->a, self->g * self->a, self->b * self->a, self->a);
}
void smoke_tick(void) {
    int i = 0;
    while (i < smoke->active) {
        Particle * p = land_array_get_nth(smoke->particles, i);
        particle_tick(p);
        if (p->t <= 0) {
            smoke->active--;
            land_array_swap(smoke->particles, i, smoke->active);
        }
#line 148
        else {
#line 150
            i++;
        }
    }
}
#line 152
void smoke_draw(LandView * view) {
    for (int i = 0; i < smoke->active; i += 1) {
        Particle * p = land_array_get_nth(smoke->particles, i);
        particle_draw(p, view);
    }
}
/* This file was generated by scramble.py. */
