/* This file was generated by scramble.py. */
#line 1 "src/sprite.py"
#include "sprite.h"
#line 25
Sprite* sprite_new(Animation * animation) {
    Sprite * self;
    land_alloc(self);
    self->super.type = & animation->super;
    self->health = animation->max_health;
    return self;
}
void sprite_draw(Sprite * self, LandView * view) {
    LandSprite * super = & self->super;
    Animation * animation = (void *) self->super.type;
    Game * game = game_global();
#line 37
    if (debug_grid & 2) {
        land_thickness(0);
        float x = (self->super.x - view->scroll_x) * view->scale_x + view->x;
        float y = (self->super.y - view->scroll_y) * view->scale_y + view->y;
        x -= animation->super.x;
        y -= animation->super.y;
        land_color(1, 0, 0, 1);
#line 45
        land_rectangle(x, y, x + self->super.type->w * view->scale_x, y + self->super.type->h * view->scale_y);
        float r = animation->radius;
        float cx = x + animation->super.x;
        float cy = y + animation->super.y;
        land_circle(cx - r, cy - r / 2, cx + r, cy + r / 2);
    }
    int f = 0;
    int a = self->frame;
    if (animation->stationary) {
        f = a;
    }
#line 55
    else if (animation->around) {
        a += game->tick;
        f = a % animation->frame_count;
        f += 3 * animation->frame_count;
    }
#line 58
    else {
#line 60
        if (animation->continuous) {
            a += game->tick / 4;
        }
#line 62
        a %= 8;
        if (a > 4) {
            a = 8 - a;
        }
        int d = 3;
        if (animation->directional) {
            d = self->direction;
        }
#line 69
        d %= 8;
        f = a + d * 5;
    }
    LandFloat x = super->x;
    LandFloat y = super->y;
    x -= view->scroll_x + view->x;
    y -= view->scroll_y + view->y;
    x -= animation->super.x;
    y -= animation->super.y;
    AtlasSprite * s = land_array_get_nth(animation->frames, f);
    //land_image_clip(s.sheet->image, s.x, s.y, s.x + s.w, s.y + s.h)
    // shadow
    //land_push_transform()
    //land_translate(x, y + s.oy / 2.0 + s.h * 0.75 + 0.1 - 2)
    //land_scale(1, -.5)
    //land_translate(0, -s.oy / 2.0)
    //land_scale(0.5, 0.5)
    //land_translate(s.ox - s.x, s.oy - s.y)
    //land_image_draw_tinted(s.sheet->image, 0, 0, 0, 0, 0, 0.2)
    //land_pop_transform()
#line 91
    LandFloat y2 = y + s->oy / 2.0 + s->h * 0.75 + 0.1 - 6;
    batch_add_tint((s->ox) * 0.5 + x, ((s->oy + s->h) * 0.5 - s->oy * 0.5) * (- .5) + y2, s->x, s->y + s->h, 0, 0, 0, 0.2);
    batch_add_tint((s->ox + s->w) * 0.5 + x, ((s->oy + s->h) * 0.5 - s->oy * 0.5) * (- .5) + y2, s->x + s->w, s->y + s->h, 0, 0, 0, 0.2);
    batch_add_tint((s->ox) * 0.5 + x, ((s->oy) * 0.5 - s->oy * 0.5) * (- .5) + y2, s->x, s->y, 0, 0, 0, 0.2);
    batch_add_tint_tri((s->ox + s->w) * 0.5 + x, ((s->oy) * 0.5 - s->oy * 0.5) * (- .5) + y2, s->x + s->w, s->y, 0, 0, 0, 0.2);
    // actual sprite
    //land_push_transform()
    //land_translate(x, y)
    //land_scale(0.5, 0.5)
    //land_translate(s.ox - s.x, s.oy - s.y)
    //land_image_draw(s.sheet->image, 0, 0)
    //land_pop_transform()
#line 105
    batch_add((s->ox) * 0.5 + x, (s->oy + s->h) * 0.5 + y, s->x, s->y + s->h);
    batch_add((s->ox + s->w) * 0.5 + x, (s->oy + s->h) * 0.5 + y, s->x + s->w, s->y + s->h);
    batch_add((s->ox) * 0.5 + x, (s->oy) * 0.5 + y, s->x, s->y);
    batch_add_tri((s->ox + s->w) * 0.5 + x, (s->oy) * 0.5 + y, s->x + s->w, s->y);
#line 110
    if ((debug_grid & 2) && self->selected) {
        float cx = (self->super.x - view->scroll_x) * view->scale_x + view->x;
        float cy = (self->super.y - view->scroll_y) * view->scale_y + view->y;
        land_color(0, 1, 0, 1);
        float r = 20;
        land_circle(cx - r, cy - r, cx + r, cy + r);
    }
}
#line 117
void sprite_heal(Sprite * self, int x) {
    Game * game = game_global();
    if (game->tick > self->tick_cast + 60) {
        self->tick_cast = game->tick;
    }
#line 120
    else {
#line 120
        return ;
    }
#line 123
    Animation * a = (void *) self->super.type;
    if (self->health >= a->max_health) {
#line 124
        return ;
    }
    self->health += x;
    if (self->health > a->max_health) {
        self->health = a->max_health;
    }
    play_bells();
#line 132
    for (int si = 0; si < 10; si += 1) {
#line 134
        smoke_add_spark(self->super.x + land_rnd(- 6, 6), self->super.y + land_rnd(- 3, 3));
    }
}
#line 136
void sprite_direction(Sprite * self, float dx, float dy) {
    float a = round(atan2(dx, dy) / pi * 4 + 9);
    self->direction = ((int) a) % 8;
}
/* This file was generated by scramble.py. */
